static const char file_id[] = "CG96PortHole.cc";
/******************************************************************
Version identification:
@(#)CG96PortHole.cc	1.6	11/25/92

Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY 
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF 
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.
							COPYRIGHTENDKEY

 Programmer: E. A. Lee

 These classes are portholes for stars that generate assembly language code.  

*******************************************************************/
#ifdef __GNUG__
#pragma implementation
#endif

#include "CG96PortHole.h"

int InCG96Port :: isItInput() const { return TRUE; }
int OutCG96Port :: isItOutput() const { return TRUE; }
int MultiInCG96Port :: isItInput() const { return TRUE; }
int MultiOutCG96Port :: isItOutput() const { return TRUE; }

PortHole& MultiInCG96Port :: newPort () {
        LOG_NEW; PortHole& p = *new InCG96Port;
        p.numberTokens = numberTokens;
        return installPort(p);
}

PortHole& MultiOutCG96Port :: newPort () {
	LOG_NEW; OutCG96Port* p = new OutCG96Port;
        p->numberTokens = numberTokens;
	forkProcessing(*p);
        return installPort(*p);
}
