defstar {
	name { Exp }
	domain { CG96 }
	desc { exponentiation }
	version { @(#)CG96Exp.pl	1.6 12/1/92 }
	author { Chih-Tsung Huang }
        acknowledge { Gabriel version by Anthony Wong }
	copyright {
Copyright (c) 1990, 1991, 1992 The Regents of the University of California.
All rights reserved.
See the file ~ptolemy/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { CG96 nonlinear functions library }
	explanation {
Exponentiation operation, out = base^in, default base = e
	}
	execTime {
		return 33;
	}
	input {
		name {input}
		type {float}
	}
	output {
		name {output}
		type {float}
	}
        state {
                name {base}
	        type {float}
	        desc { base value }
	        default { 2.7182818284 }
	}
        state {
                name {constant}
	        type {floatarray}
	        desc { internal }
	        default {
"-0.5770606e-03 0.2093549e-02 -0.2777411e-03 0.3357901e-02 0.8940958e-02 0.5558203e-01 0.2402348e+00 0.6931450e+00 0.1000000e+01"
              	}
                attributes {A_CONSTANT|A_NONSETTABLE|A_YMEM}
	}    
        state {
                name {X}
	        type {float}
	        desc { internal }
	        default { 0 }
                attributes {A_CONSTANT|A_NONSETTABLE}
	}    
	codeblock (expblock) {
        move    $ref(input),d0.s
        move    #$val(X),d3.s
        move    #<$addr(constant),r0
        fmpy.x  d0,d3,d0        #1.442695041,d2.s
        fmpy.x  d0,d2,d0
        floor   d0,d7
        fsub.x  d7,d0
        fclr    d2      y:(r0)+,d1.s
        int     d7
        do      #9,$label(loop)
        fmpy.x  d2,d0,d2        d7.l,d7.h
        fadd.x  d1,d2           y:(r0)+,d1.s
$label(loop)
        fscale.s        d7,d2
        move    d2.s,$ref(output)
	}

    
	go {
                X=log(base);
		addCode(expblock);
	}
}
