extern char *malloc(), *realloc();

# line 36 "pass1Syn.y"
#ifdef _IBMR2
#pragma alloca
#endif

#include <stdio.h>
#include <string.h>
#include "comdefs.h"

extern char pp1text[];
extern int  pp1lineno;
extern int  pp1lex();

DECSTRUCT *DeclHead=NULL;
SIGSTRUCT *TmpSigs=NULL;
VARLISTSTRUCT VarList = {NULL,NULL,NULL};
extern ICL *iclptr;
extern char *VGrpSize;

FILE *ccfile = NULL, *modfile = NULL, *cctmp = NULL;
FILE *p1lexout=NULL;
int NewLine, ModelType, IsThorModel=0;
NAMETABLE *vectorTable = 0;

# line 60 "pass1Syn.y"
typedef union  {
    char	*str;
    int		 ival;
    SIGSTRUCT	*sprop;
    DECSTRUCT	*dprop;
} PP1STYPE;
# define MODEL 257
# define WORD 258
# define IN_LIST 259
# define OUT_LIST 260
# define BI_LIST 261
# define ST_LIST 262
# define ENDLIST 263
# define INT 264
# define SIG 265
# define TSIG 266
# define GRP 267
# define TGRP 268
# define VGRP 269
# define BIGEND 270
# define LITTLEEND 271
# define CVAR 272
# define PRIVATE 273
# define PROTECTED 274
# define PUBLIC 275
#define pp1clearin pp1char = -1
#define pp1errok pp1errflag = 0
extern int pp1char;
extern int pp1errflag;
#ifndef PP1MAXDEPTH
#define PP1MAXDEPTH 150
#endif
PP1STYPE pp1lval, pp1val;
# define PP1ERRCODE 256

# line 266 "pass1Syn.y"


static char identification[] = "@(#)pass1Syn.y	1.4\t7/16/92  (c) UC Berkeley";

pp1error(s)
    char *s;
{
    errmsg("s","\"%s\", line %3d: %s at or near \"%s\".\n",
	   FileIParse, pp1lineno, s, pp1text);
}

	/*
	 * This function is called to parse the thor model file and create a
	 * C++ file when done. The parameters are;
	 *	infile:      file pointer to file to be parsed.
	 *	infilename:  name of file to be parsed.
	 *	outfile:     file pointer to file to be parsed.
	 *	tfile:       file pointer to temporary file.
	 *	TypeOfModel: The kind of model it should response as.
	 *		     If passed value = 0, then the combination of
	 *		     in and outputs will determine the kind of
	 *		     model to use.
	 *	vecTbl:      the address to a pointer to a table of all
	 *		     declared thor vectors and their sizes.
	 *
	 */

int pass1(infile,infilename,outfile,tfile,TypeOfModel,vecTbl)
    FILE *infile, *outfile, *tfile;
    char *infilename;
    int TypeOfModel;
    NAMETABLE **vecTbl;
{
    int rval = 0;
    vectorTable = 0;
    IsThorModel=0;
    VarList.private = VarList.protected = VarList.public = NULL;
    if (!infile) {
	errmsg("f","pass1: no infile opened!\n");
	return 3;
    }
    if (!outfile) {
	errmsg("f","pass1: no outfile opened!\n");
	return 4;
    }
    if (!tfile) {
	errmsg("f","pass1: no tempfile opened!\n");
	return 5;
    }
    modfile = infile; ccfile = outfile; cctmp = tfile;
    p1lexout = ccfile;
    if (infilename)
	FileIParse = infilename;
    else
	FileIParse = "(stdin)";
    ModelType = TypeOfModel;
    if (pp1parse())
	rval = 2;
    if (!IsThorModel) {
	errmsg("s","\"%s\", line %3d: warning: No `MODEL()' declaration found.\n",
	       FileIParse, pp1lineno-1);
	rval = 1;
    }
    ccfile = modfile = cctmp = NULL; FileIParse = NULL;
    iclptr = freeIclList(iclptr);
    if (debug) {
	char *descbuf;
	errmsg("s","Vector declaration list:\n");
	printDecList(DeclHead);
	errmsg("s","Name table contents:\n");
	printNameTbl(vectorTable);
	errmsg("s","\nDeclared C++ variable:\n");
	printVarList(&VarList);
	errmsg("s","\n");
	if (descbuf = getdescriptor()) {
	    errmsg("s","Descriptor string: (len = %d, bufsize = %d)\n",
		   strlen(descbuf), 2*BUFSIZ);
	    errmsg("s",descbuf);
	}
    }
    DeclHead = freeDecList(DeclHead);
    TmpSigs = freeSigList(TmpSigs);
    VarList.private = freeVarList(VarList.private);
    VarList.protected = freeVarList(VarList.protected);
    VarList.public = freeVarList(VarList.public);
    *vecTbl = vectorTable;
    return rval;
}
int pp1exca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define PP1NPROD 35
# define PP1LAST 152
int pp1act[]={

     7,     8,     9,    10,    89,    90,    91,    13,    71,    14,
    96,    97,    41,    15,    20,    21,    22,    23,    24,    40,
    70,    20,    21,    22,    23,    24,    39,    67,    20,    21,
    22,    23,    24,    32,     3,    20,    21,    22,    23,    24,
    20,    21,    22,    23,    24,    66,    93,    94,    86,    87,
    73,    74,    51,    50,    49,    48,    47,    44,    43,    42,
    31,    58,   117,   116,   115,   114,   113,   112,   111,   110,
   109,    99,    98,    95,    92,    88,    85,    72,    69,    68,
    65,    54,    53,    52,    46,    81,    79,    77,    82,    80,
    78,    75,    63,    62,    76,    64,    61,    57,    56,   108,
   107,   106,   105,   104,   103,   102,   101,   100,    84,    83,
    60,    59,    55,    45,    38,    37,    36,    35,    34,    30,
    29,    28,    16,    19,    18,     6,     4,     2,     1,    12,
    11,    17,     5,    25,    26,    27,     0,     0,     0,     0,
     0,     0,    33,     0,     0,     0,     0,     0,     0,    33,
    33,    33 };
int pp1pact[]={

  -223, -1000,  -259,    82, -1000,  -259, -1000,  -225,  -225,  -225,
  -225, -1000, -1000,    81,    80,    79,  -198, -1000,  -230, -1000,
    78,    77,    76,    75,    74,  -237,  -244,  -251,  -199,  -200,
  -201,    72,    25, -1000,  -202,  -203,  -204,  -205,  -206,    24,
    23,    22,    71,    54,    53,   -62, -1000,    70,    69,    52,
    49,    51, -1000, -1000, -1000,    21,  -213,  -231, -1000,    20,
    19,  -238,  -250,    18,  -220, -1000,    50,    46, -1000, -1000,
    45,    44, -1000,    68,    67,    17,  -222,    16,  -269,    15,
  -224,    14,  -260,    13,    12, -1000,    66,    65, -1000,    64,
    63,    62, -1000,    61,    60, -1000,    59,    58, -1000, -1000,
    11,    10,     9,     8,     7,     6,     5,     4,     3, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000 };
int pp1pgo[]={

     0,   132,   125,   124,   123,   130,   129,   128,   127,   126 };
int pp1r1[]={

     0,     7,     7,     8,     9,     9,     1,     1,     2,     2,
     2,     2,     2,     2,     5,     5,     5,     5,     3,     3,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     6,     6,     6,     6 };
int pp1r2[]={

     0,     0,     5,    11,     1,     3,     3,     5,     9,     9,
     9,     9,     3,     3,    11,    15,    19,    19,     2,     5,
    11,    11,    15,    19,    19,    15,    19,    19,    11,    15,
    15,    15,    19,    19,    19 };
int pp1chk[]={

 -1000,    -7,    -8,   257,    -9,    -1,    -2,   259,   260,   261,
   262,    -5,    -6,   266,   268,   272,    40,    -2,    -3,    -4,
   265,   266,   267,   268,   269,    -3,    -3,    -3,    40,    40,
    40,   258,   263,    -4,    40,    40,    40,    40,    40,   263,
   263,   263,   258,   258,   258,    41,    59,   258,   258,   258,
   258,   258,    59,    59,    59,    41,    44,    44,   123,    41,
    41,    44,    44,    41,    44,    59,   258,   258,    59,    59,
   258,   258,    59,   270,   271,    41,    44,    41,    44,    41,
    44,    41,    44,    41,    41,    59,   270,   271,    59,   273,
   274,   275,    59,   270,   271,    59,   270,   271,    59,    59,
    41,    41,    41,    41,    41,    41,    41,    41,    41,    59,
    59,    59,    59,    59,    59,    59,    59,    59 };
int pp1def[]={

     1,    -2,     4,     0,     2,     5,     6,     0,     0,     0,
     0,    12,    13,     0,     0,     0,     0,     7,     0,    18,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    19,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     8,     0,     0,     0,
     0,     0,     9,    10,    11,     0,     0,     0,     3,     0,
     0,     0,     0,     0,     0,    14,     0,     0,    20,    21,
     0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    15,     0,     0,    31,     0,
     0,     0,    22,     0,     0,    25,     0,     0,    29,    30,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
    17,    32,    33,    34,    23,    24,    26,    27 };
typedef struct { char *t_name; int t_val; } pp1toktype;
#ifndef PP1DEBUG
#	define PP1DEBUG	0	/* don't allow debugging */
#endif

#if PP1DEBUG

pp1toktype pp1toks[] =
{
	"MODEL",	257,
	"WORD",	258,
	"IN_LIST",	259,
	"OUT_LIST",	260,
	"BI_LIST",	261,
	"ST_LIST",	262,
	"ENDLIST",	263,
	"INT",	264,
	"SIG",	265,
	"TSIG",	266,
	"GRP",	267,
	"TGRP",	268,
	"VGRP",	269,
	"BIGEND",	270,
	"LITTLEEND",	271,
	"CVAR",	272,
	"PRIVATE",	273,
	"PROTECTED",	274,
	"PUBLIC",	275,
	"-unknown-",	-1	/* ends search */
};

char * pp1reds[] =
{
	"-no such reduction-",
	"begin : /* empty */",
	"begin : mod_id mod_body",
	"mod_id : MODEL '(' WORD ')' '{'",
	"mod_body : /* empty */",
	"mod_body : list_decls",
	"list_decls : list_decl",
	"list_decls : list_decls list_decl",
	"list_decl : IN_LIST signals ENDLIST ';'",
	"list_decl : OUT_LIST signals ENDLIST ';'",
	"list_decl : BI_LIST signals ENDLIST ';'",
	"list_decl : ST_LIST signals ENDLIST ';'",
	"list_decl : temp_sigs",
	"list_decl : classvar",
	"temp_sigs : TSIG '(' WORD ')' ';'",
	"temp_sigs : TGRP '(' WORD ',' WORD ')' ';'",
	"temp_sigs : TGRP '(' WORD ',' WORD ',' BIGEND ')' ';'",
	"temp_sigs : TGRP '(' WORD ',' WORD ',' LITTLEEND ')' ';'",
	"signals : signal",
	"signals : signals signal",
	"signal : SIG '(' WORD ')' ';'",
	"signal : TSIG '(' WORD ')' ';'",
	"signal : GRP '(' WORD ',' WORD ')' ';'",
	"signal : GRP '(' WORD ',' WORD ',' BIGEND ')' ';'",
	"signal : GRP '(' WORD ',' WORD ',' LITTLEEND ')' ';'",
	"signal : TGRP '(' WORD ',' WORD ')' ';'",
	"signal : TGRP '(' WORD ',' WORD ',' BIGEND ')' ';'",
	"signal : TGRP '(' WORD ',' WORD ',' LITTLEEND ')' ';'",
	"signal : VGRP '(' WORD ')' ';'",
	"signal : VGRP '(' WORD ',' BIGEND ')' ';'",
	"signal : VGRP '(' WORD ',' LITTLEEND ')' ';'",
	"classvar : CVAR '(' WORD ',' WORD ')' ';'",
	"classvar : CVAR '(' WORD ',' WORD ',' PRIVATE ')' ';'",
	"classvar : CVAR '(' WORD ',' WORD ',' PROTECTED ')' ';'",
	"classvar : CVAR '(' WORD ',' WORD ',' PUBLIC ')' ';'",
};
#endif /* PP1DEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define PP1ERROR		goto pp1errlab
#define PP1ACCEPT	{ free(pp1s); free(pp1v); return(0); }
#define PP1ABORT		{ free(pp1s); free(pp1v); return(1); }
#define PP1BACKUP( newtoken, newvalue )\
{\
	if ( pp1char >= 0 || ( pp1r2[ pp1tmp ] >> 1 ) != 1 )\
	{\
		pp1error( "syntax error - cannot backup" );\
		goto pp1errlab;\
	}\
	pp1char = newtoken;\
	pp1state = *pp1ps;\
	pp1lval = newvalue;\
	goto pp1newstate;\
}
#define PP1RECOVERING()	(!!pp1errflag)
#ifndef PP1DEBUG
#	define PP1DEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int pp1debug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define PP1FLAG		(-1000)

/*
** static variables used by the parser
*/
static PP1STYPE *pp1v;			/* value stack */
static int *pp1s;			/* state stack */

static PP1STYPE *pp1pv;			/* top of value stack */
static int *pp1ps;			/* top of state stack */

static int pp1state;			/* current state */
static int pp1tmp;			/* extra var (lasts between blocks) */

int pp1nerrs;			/* number of errors */

int pp1errflag;			/* error recovery flag */
int pp1char;			/* current input token number */


/*
** pp1parse - return 0 if worked, 1 if syntax error not recovered from
*/
int
pp1parse()
{
	register PP1STYPE *pp1pvt;	/* top of value stack for $vars */
	unsigned pp1maxdepth = PP1MAXDEPTH;

	/*
	** Initialize externals - pp1parse may be called more than once
	*/
	pp1v = (PP1STYPE*)malloc(pp1maxdepth*sizeof(PP1STYPE));
	pp1s = (int*)malloc(pp1maxdepth*sizeof(int));
	if (!pp1v || !pp1s)
	{
		pp1error( "out of memory" );
		return(1);
	}
	pp1pv = &pp1v[-1];
	pp1ps = &pp1s[-1];
	pp1state = 0;
	pp1tmp = 0;
	pp1nerrs = 0;
	pp1errflag = 0;
	pp1char = -1;

	goto pp1stack;
	{
		register PP1STYPE *pp1_pv;	/* top of value stack */
		register int *pp1_ps;		/* top of state stack */
		register int pp1_state;		/* current state */
		register int  pp1_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if PP1BACKUP was called.
		*/
	pp1newstate:
		pp1_pv = pp1pv;
		pp1_ps = pp1ps;
		pp1_state = pp1state;
		goto pp1_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	pp1stack:
		pp1_pv = pp1pv;
		pp1_ps = pp1ps;
		pp1_state = pp1state;

		/*
		** top of for (;;) loop while no reductions done
		*/
	pp1_stack:
		/*
		** put a state and value onto the stacks
		*/
#if PP1DEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( pp1debug )
		{
			register int pp1_i;

			(void)printf( "State %d, token ", pp1_state );
			if ( pp1char == 0 )
				(void)printf( "end-of-file\n" );
			else if ( pp1char < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( pp1_i = 0; pp1toks[pp1_i].t_val >= 0;
					pp1_i++ )
				{
					if ( pp1toks[pp1_i].t_val == pp1char )
						break;
				}
				(void)printf( "%s\n", pp1toks[pp1_i].t_name );
			}
		}
#endif /* PP1DEBUG */
		if ( ++pp1_ps >= &pp1s[ pp1maxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int pp1ps_index = (pp1_ps - pp1s);
			int pp1pv_index = (pp1_pv - pp1v);
			int pp1pvt_index = (pp1pvt - pp1v);
			pp1maxdepth += PP1MAXDEPTH;
			pp1v = (PP1STYPE*)realloc((char*)pp1v,
				pp1maxdepth * sizeof(PP1STYPE));
			pp1s = (int*)realloc((char*)pp1s,
				pp1maxdepth * sizeof(int));
			if (!pp1v || !pp1s)
			{
				pp1error( "yacc stack overflow" );
				return(1);
			}
			pp1_ps = pp1s + pp1ps_index;
			pp1_pv = pp1v + pp1pv_index;
			pp1pvt = pp1v + pp1pvt_index;
		}
		*pp1_ps = pp1_state;
		*++pp1_pv = pp1val;

		/*
		** we have a new state - find out what to do
		*/
	pp1_newstate:
		if ( ( pp1_n = pp1pact[ pp1_state ] ) <= PP1FLAG )
			goto pp1default;		/* simple state */
#if PP1DEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		pp1tmp = pp1char < 0;
#endif
		if ( ( pp1char < 0 ) && ( ( pp1char = pp1lex() ) < 0 ) )
			pp1char = 0;		/* reached EOF */
#if PP1DEBUG
		if ( pp1debug && pp1tmp )
		{
			register int pp1_i;

			(void)printf( "Received token " );
			if ( pp1char == 0 )
				(void)printf( "end-of-file\n" );
			else if ( pp1char < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( pp1_i = 0; pp1toks[pp1_i].t_val >= 0;
					pp1_i++ )
				{
					if ( pp1toks[pp1_i].t_val == pp1char )
						break;
				}
				(void)printf( "%s\n", pp1toks[pp1_i].t_name );
			}
		}
#endif /* PP1DEBUG */
		if ( ( ( pp1_n += pp1char ) < 0 ) || ( pp1_n >= PP1LAST ) )
			goto pp1default;
		if ( pp1chk[ pp1_n = pp1act[ pp1_n ] ] == pp1char )	/*valid shift*/
		{
			pp1char = -1;
			pp1val = pp1lval;
			pp1_state = pp1_n;
			if ( pp1errflag > 0 )
				pp1errflag--;
			goto pp1_stack;
		}

	pp1default:
		if ( ( pp1_n = pp1def[ pp1_state ] ) == -2 )
		{
#if PP1DEBUG
			pp1tmp = pp1char < 0;
#endif
			if ( ( pp1char < 0 ) && ( ( pp1char = pp1lex() ) < 0 ) )
				pp1char = 0;		/* reached EOF */
#if PP1DEBUG
			if ( pp1debug && pp1tmp )
			{
				register int pp1_i;

				(void)printf( "Received token " );
				if ( pp1char == 0 )
					(void)printf( "end-of-file\n" );
				else if ( pp1char < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( pp1_i = 0;
						pp1toks[pp1_i].t_val >= 0;
						pp1_i++ )
					{
						if ( pp1toks[pp1_i].t_val
							== pp1char )
						{
							break;
						}
					}
					(void)printf( "%s\n", pp1toks[pp1_i].t_name );
				}
			}
#endif /* PP1DEBUG */
			/*
			** look through exception table
			*/
			{
				register int *pp1xi = pp1exca;

				while ( ( *pp1xi != -1 ) ||
					( pp1xi[1] != pp1_state ) )
				{
					pp1xi += 2;
				}
				while ( ( *(pp1xi += 2) >= 0 ) &&
					( *pp1xi != pp1char ) )
					;
				if ( ( pp1_n = pp1xi[1] ) < 0 )
					PP1ACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( pp1_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( pp1errflag )
			{
			case 0:		/* new error */
				pp1error( "syntax error" );
				goto skip_init;
			pp1errlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				pp1_pv = pp1pv;
				pp1_ps = pp1ps;
				pp1_state = pp1state;
				pp1nerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				pp1errflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( pp1_ps >= pp1s )
				{
					pp1_n = pp1pact[ *pp1_ps ] + PP1ERRCODE;
					if ( pp1_n >= 0 && pp1_n < PP1LAST &&
						pp1chk[pp1act[pp1_n]] == PP1ERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						pp1_state = pp1act[ pp1_n ];
						goto pp1_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if PP1DEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( pp1debug )
						(void)printf( _POP_, *pp1_ps,
							pp1_ps[-1] );
#	undef _POP_
#endif
					pp1_ps--;
					pp1_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				PP1ABORT;
			case 3:		/* no shift yet; eat a token */
#if PP1DEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( pp1debug )
				{
					register int pp1_i;

					(void)printf( "Error recovery discards " );
					if ( pp1char == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( pp1char < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( pp1_i = 0;
							pp1toks[pp1_i].t_val >= 0;
							pp1_i++ )
						{
							if ( pp1toks[pp1_i].t_val
								== pp1char )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							pp1toks[pp1_i].t_name );
					}
				}
#endif /* PP1DEBUG */
				if ( pp1char == 0 )	/* reached EOF. quit */
					PP1ABORT;
				pp1char = -1;
				goto pp1_newstate;
			}
		}/* end if ( pp1_n == 0 ) */
		/*
		** reduction by production pp1_n
		** put stack tops, etc. so things right after switch
		*/
#if PP1DEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( pp1debug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				pp1_n, pp1reds[ pp1_n ] );
#endif
		pp1tmp = pp1_n;			/* value to switch over */
		pp1pvt = pp1_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using pp1_state here as temporary
		** register variable, but why not, if it works...
		** If pp1r2[ pp1_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto pp1_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int pp1_len = pp1r2[ pp1_n ];

			if ( !( pp1_len & 01 ) )
			{
				pp1_len >>= 1;
				pp1val = ( pp1_pv -= pp1_len )[1];	/* $$ = $1 */
				pp1_state = pp1pgo[ pp1_n = pp1r1[ pp1_n ] ] +
					*( pp1_ps -= pp1_len ) + 1;
				if ( pp1_state >= PP1LAST ||
					pp1chk[ pp1_state =
					pp1act[ pp1_state ] ] != -pp1_n )
				{
					pp1_state = pp1act[ pp1pgo[ pp1_n ] ];
				}
				goto pp1_stack;
			}
			pp1_len >>= 1;
			pp1val = ( pp1_pv -= pp1_len )[1];	/* $$ = $1 */
			pp1_state = pp1pgo[ pp1_n = pp1r1[ pp1_n ] ] +
				*( pp1_ps -= pp1_len ) + 1;
			if ( pp1_state >= PP1LAST ||
				pp1chk[ pp1_state = pp1act[ pp1_state ] ] != -pp1_n )
			{
				pp1_state = pp1act[ pp1pgo[ pp1_n ] ];
			}
		}
					/* save until reenter driver code */
		pp1state = pp1_state;
		pp1ps = pp1_ps;
		pp1pv = pp1_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( pp1tmp )
	{
		
case 2:
# line 94 "pass1Syn.y"
{   make_Gofcn(cctmp,ccfile);   } break;
case 3:
# line 98 "pass1Syn.y"
{ /* prepend `Thor' to modelname ... */
				    ClassName = (char*) malloc(strlen(pp1pvt[-2].str) + 5);
				    sprintf(ClassName,"Thor%s",pp1pvt[-2].str);
				    /* Make ModelName a substring of ClassName */
				    ModelName = ClassName + 4;
				    free(pp1pvt[-2].str); /* string from lex no longer needed */
				    IsThorModel=1;
				    whereIam(cctmp,pp1lineno,FileIParse);
				} break;
case 4:
# line 110 "pass1Syn.y"
{
				    printHeader(DeclHead,TmpSigs,&VarList,
						iclptr,ccfile,ModelType);
				} break;
case 5:
# line 115 "pass1Syn.y"
{
				    printHeader(DeclHead,TmpSigs,&VarList,
						iclptr,ccfile,ModelType);
				} break;
case 6:
# line 122 "pass1Syn.y"
{   pp1val.dprop = DeclHead = pp1pvt[-0].dprop;   } break;
case 7:
# line 124 "pass1Syn.y"
{   pp1val.dprop = DeclHead = app_declists(pp1pvt[-0].dprop,pp1pvt[-1].dprop);   } break;
case 8:
# line 128 "pass1Syn.y"
{   pp1val.dprop = newdeclist(pp1pvt[-2].sprop,IN_LIST,pp1pvt[-3].ival,pp1pvt[-1].ival);   } break;
case 9:
# line 130 "pass1Syn.y"
{   pp1val.dprop = newdeclist(pp1pvt[-2].sprop,OUT_LIST,pp1pvt[-3].ival,pp1pvt[-1].ival);   } break;
case 10:
# line 132 "pass1Syn.y"
{   pp1val.dprop = newdeclist(pp1pvt[-2].sprop,BI_LIST,pp1pvt[-3].ival,pp1pvt[-1].ival);   } break;
case 11:
# line 134 "pass1Syn.y"
{   pp1val.dprop = newdeclist(pp1pvt[-2].sprop,ST_LIST,pp1pvt[-3].ival,pp1pvt[-1].ival);   } break;
case 12:
# line 136 "pass1Syn.y"
{   TmpSigs = append_sigs(pp1pvt[-0].sprop,TmpSigs);
				    pp1val.dprop = NULL;
				} break;
case 13:
# line 139 "pass1Syn.y"
{  pp1val.dprop = NULL;  } break;
case 14:
# line 143 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-2].str,TSIG,"1",-1,pp1pvt[-4].ival);
				    free(pp1pvt[-2].str);
				} break;
case 15:
# line 147 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-4].str,TGRP,pp1pvt[-2].str,BIGEND,pp1pvt[-6].ival);
				    vectorTable = insertname(pp1pvt[-4].str,pp1pvt[-2].str,BIG_END,vectorTable,pp1pvt[-6].ival);
				    free(pp1pvt[-4].str); free(pp1pvt[-2].str);
				} break;
case 16:
# line 152 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-6].str,TGRP,pp1pvt[-4].str,BIGEND,pp1pvt[-8].ival);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,BIG_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 17:
# line 157 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-6].str,TGRP,pp1pvt[-4].str,LITTLEEND,pp1pvt[-8].ival);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,LIT_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 19:
# line 165 "pass1Syn.y"
{   append_sigs(pp1pvt[-0].sprop,pp1pvt[-1].sprop);   } break;
case 20:
# line 169 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-2].str,SIG,"1",-1,pp1pvt[-4].ival);
				    free(pp1pvt[-2].str);
				} break;
case 21:
# line 173 "pass1Syn.y"
{   pp1val.sprop = NULL;
				    TmpSigs = append_sigs(newsig(pp1pvt[-2].str,TSIG,"1",-1,pp1pvt[-4].ival),TmpSigs);
				    free(pp1pvt[-2].str);
				} break;
case 22:
# line 178 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-4].str,GRP,pp1pvt[-2].str,BIGEND,pp1pvt[-6].ival);
				    vectorTable = insertname(pp1pvt[-4].str,pp1pvt[-2].str,BIG_END,vectorTable,pp1pvt[-6].ival);
				    free(pp1pvt[-4].str); free(pp1pvt[-2].str);
				} break;
case 23:
# line 183 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-6].str,GRP,pp1pvt[-4].str,BIGEND,pp1pvt[-8].ival);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,BIG_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 24:
# line 188 "pass1Syn.y"
{   pp1val.sprop = newsig(pp1pvt[-6].str,GRP,pp1pvt[-4].str,LITTLEEND,pp1pvt[-8].ival);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,LIT_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 25:
# line 193 "pass1Syn.y"
{   pp1val.sprop = NULL;
				    TmpSigs = append_sigs(newsig(pp1pvt[-4].str,TGRP,pp1pvt[-2].str,BIGEND,pp1pvt[-6].ival),TmpSigs);
				    vectorTable = insertname(pp1pvt[-4].str,pp1pvt[-2].str,BIG_END,vectorTable,pp1pvt[-6].ival);
				    free(pp1pvt[-4].str); free(pp1pvt[-2].str);
				} break;
case 26:
# line 199 "pass1Syn.y"
{   pp1val.sprop = NULL;
				    TmpSigs = append_sigs(newsig(pp1pvt[-6].str,TGRP,pp1pvt[-4].str,BIGEND,pp1pvt[-8].ival),TmpSigs);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,BIG_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 27:
# line 205 "pass1Syn.y"
{   pp1val.sprop = NULL;
				    TmpSigs = append_sigs(newsig(pp1pvt[-6].str,TGRP,pp1pvt[-4].str,LITTLEEND,pp1pvt[-8].ival),TmpSigs);
				    vectorTable = insertname(pp1pvt[-6].str,pp1pvt[-4].str,LIT_END,vectorTable,pp1pvt[-8].ival);
				    free(pp1pvt[-6].str); free(pp1pvt[-4].str);
				} break;
case 28:
# line 211 "pass1Syn.y"
{   char *sz = (char *)
					malloc(strlen(pp1pvt[-2].str)+strlen(VGrpSize)+1);
				    sprintf(sz,VGrpSize,pp1pvt[-2].str);
				    pp1val.sprop = newsig(pp1pvt[-2].str,VGRP,sz,BIGEND,pp1pvt[-4].ival);
				    vectorTable = insertname(pp1pvt[-2].str,sz,BIG_END,vectorTable,pp1pvt[-4].ival);
				    free(pp1pvt[-2].str); free(sz);
				} break;
case 29:
# line 219 "pass1Syn.y"
{   char *sz = (char *)
					malloc(strlen(pp1pvt[-4].str)+strlen(VGrpSize)+1);
				    sprintf(sz,VGrpSize,pp1pvt[-4].str);
				    pp1val.sprop = newsig(pp1pvt[-4].str,VGRP,sz,BIGEND,pp1pvt[-6].ival);
				    vectorTable = insertname(pp1pvt[-4].str,sz,BIG_END,vectorTable,pp1pvt[-6].ival);
				    free(pp1pvt[-4].str); free(sz);
				} break;
case 30:
# line 227 "pass1Syn.y"
{   char *sz = (char *)
					malloc(strlen(pp1pvt[-4].str)+strlen(VGrpSize)+1);
				    sprintf(sz,VGrpSize,pp1pvt[-4].str);
				    pp1val.sprop = newsig(pp1pvt[-4].str,VGRP,sz,LITTLEEND,pp1pvt[-6].ival);
				    vectorTable = insertname(pp1pvt[-4].str,sz,LIT_END,vectorTable,pp1pvt[-6].ival);
				    free(pp1pvt[-4].str); free(sz);
				} break;
case 31:
# line 238 "pass1Syn.y"
{
				    VarList.private =
					append_vars(newvar(pp1pvt[-4].str,pp1pvt[-2].str,pp1pvt[-6].ival),
						    VarList.private);
				} break;
case 32:
# line 245 "pass1Syn.y"
{
				    VarList.private =
					append_vars(newvar(pp1pvt[-6].str,pp1pvt[-4].str,pp1pvt[-8].ival),
						    VarList.private);
				} break;
case 33:
# line 252 "pass1Syn.y"
{
				    VarList.protected =
					append_vars(newvar(pp1pvt[-6].str,pp1pvt[-4].str,pp1pvt[-8].ival),
						    VarList.protected);
				} break;
case 34:
# line 259 "pass1Syn.y"
{
				    VarList.public =
					append_vars(newvar(pp1pvt[-6].str,pp1pvt[-4].str,pp1pvt[-8].ival),
						    VarList.public);
				} break;
	}
	goto pp1stack;		/* reset registers in driver code */
}
